#ifndef _clerk2_h_
#define _clerk2_h_
#include "adevs.h"
#include "customer.h"
#include <list>

class clerk2: public atomic 
{
	public:
		/// Constructor.
		clerk2():
		atomic(),
		line(),
		preempt(0.0)
		{
		}
		/// State initialization function.
		void init();
		/// Internal transition function.
		void delta_int();
		/// External transition function.
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x);
		/// Confluent transition function.
		void delta_conf(const adevs_bag<PortValue>& x);
		/// Output function.  
		void output_func(adevs_bag<PortValue>& y);
		/// Output value garbage collection.
		void gc_output(adevs_bag<PortValue>& g);
		/// Destructor.
		~clerk2();
		/// Model input port.
		static const port_t arrive;
		/// Model output port.
		static const port_t depart;

	private:	
		/// List of waiting customers.
		std::list<customer*> line;
		//// Time before we can preempt another customer
		double preempt;
		/// Threshold correspond to a 'small' order processing time
		static const double SMALL_ORDER;
		/// Minimum time between preemptions.
		static const double PREEMPT_TIME;
		/// Delete all waiting customers and clear the list.
		void empty_line();
}; 

#endif
