#include "generator.h"
using namespace std;

const port_t generator::arrive = 0;

void generator::init()
{
	input_strm.seekg(0,ios::beg);
	schedule_next_output();
}
	
void generator::delta_int()
{
	schedule_next_output();

	/**
	cout << "Computed the internal transition function at t = " << timeCurrent() << endl;
	cout << "The next customer will arrive at t = " << timeNext() << "." << endl;
	*/
}

void generator::delta_ext(stime_t e, const adevs_bag<PortValue>& x)
{
	/// The generator is input free, and so it ignores external events.
}

void generator::delta_conf(const adevs_bag<PortValue>& x)
{
	/// The generator is input free, and so it ignores input.
	delta_int();
}

void generator::output_func(adevs_bag<PortValue>& y)
{
	output(arrive,next.clone(),y);

	/**
	cout << "Computed the output function at t = " << timeNext() << endl;
	cout << "A customer has arrived!" << endl;
	*/
}

void generator::gc_output(adevs_bag<PortValue>& g)
{
	for (int i = 0; i < g.getSize(); i++)
	{
		delete g[i].value;
	}
}

generator::~generator()
{
	input_strm.close();
}

void generator::schedule_next_output()
{
	double tnext = 0.0;
	input_strm >> tnext >> next.twait;
	if (input_strm.eof())
	{
		passivate();
	}
	else
	{
		hold(tnext - timeCurrent());
	}
}
