#ifndef _generator_h_
#define _generator_h_
#include "adevs.h"
#include "customer.h"
#include <fstream>

class generator: public atomic 
{
	public:
		/// Constructor.
		generator(const char* data_file):
		atomic(),
		input_strm(data_file)
		{
		}
		/// State initialization function.
		void init();
		/// Internal transition function.
		void delta_int();
		/// External transition function.
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x);
		/// Confluent transition function.
		void delta_conf(const adevs_bag<PortValue>& x);
		/// Output function.  
		void output_func(adevs_bag<PortValue>& y);
		/// Output value garbage collection.
		void gc_output(adevs_bag<PortValue>& g);
		/// Destructor.
		~generator();
		/// Model output port.
		static const port_t arrive;

	private:	
		/// List of waiting customers.
		std::ifstream input_strm;
		/// Next customer.
		customer next;
		/// Schedule the next customer arrival event.
		void schedule_next_output();
}; 

#endif
