#include "customer.h"
#include "clerk.h"
#include "clerk2.h"
#include "multi_clerk.h"
#include "generator.h"
#include "observer.h"
#include "adevs.h"
using namespace std;

int main(int argc, char** argv)
{
	if (argc != 2)
	{
		cout << "Need an input file!" << endl;
		return 1;
	}
	staticDigraph store;
	multi_clerk* clrk = new multi_clerk();
	generator* genr = new generator(argv[1]);
	observer* obsrv = new observer(argv[2]);
	store.add(clrk);
	store.add(genr);
	store.add(obsrv);
	store.couple(genr,genr->arrive,clrk,clrk->arrive);
	store.couple(clrk,clrk->depart,obsrv,obsrv->depart);
	devssim sim(&store);
	sim.run(100.0);
	return 0;
}
