#include "multi_clerk.h"
using namespace std;

// Assign identifiers to I/O ports
const port_t multi_clerk::arrive = 0;
const port_t multi_clerk::depart = 1;

multi_clerk::multi_clerk():
staticDigraph()
{
	// Create and add component models
	decision* d = new decision();
	add(d);
	clerk* c[NUM_LINES];
	for (int i = 0; i < NUM_LINES; i++)
	{
		c[i] = new clerk();
		add(c[i]);
	}
	// Create model connections
	couple(this,this->arrive,d,d->decide);
	for (int i = 0; i < NUM_LINES; i++)
	{
		couple(d,d->arrive[i],c[i],c[i]->arrive);
		couple(c[i],c[i]->depart,d,d->departures[i]);
		couple(c[i],c[i]->depart,this,this->depart);
	}
}

multi_clerk::~multi_clerk()
{
}
