#ifndef _observer_h_
#define _observer_h_
#include "adevs.h"
#include "customer.h"
#include <fstream>

class observer: public atomic 
{
	public:
		/// Input port for receiving customers leaving the store.
		static const port_t departed;

		/// Constructor.
		observer(const char* results_file):
		atomic(),
		output_strm(results_file)
		{
		}
		/// State initialization function.
		void init();
		/// Internal transition function.
		void delta_int();
		/// External transition function.
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x);
		/// Confluent transition function.
		void delta_conf(const adevs_bag<PortValue>& x);
		/// Output function.  
		void output_func(adevs_bag<PortValue>& y);
		/// Output value garbage collection.
		void gc_output(adevs_bag<PortValue>& g);
		/// Destructor.
		~observer();
		/// Model output port.
		static const port_t depart;

	private:	
		/// File for storing info on departing customers.
		std::ofstream output_strm;
}; 

#endif
