#include "configuration.h"
using namespace std;

configuration::configuration(std::string config_file)
{
	std::string field;
	wind = NONE;
	data.open(config_file.c_str());
	while (!data.eof())
	{
		data >> field;
		if (data.eof()) break;
		if (field == "width") data >> width;
		else if (field == "height") data >>height;
		else if (field == "tend") data >> tend;
		else if (field == "fuel") load_fuel();
		else if (field == "fire") load_fire();
		else if (field == "wind") load_wind();
	}
	data.close();
}

void configuration::load_wind()
{
	string dir;
	data >> dir;
	if (dir == "N") wind = N;
	else if (dir == "S") wind = S;
	else if (dir == "E") wind = E;
	else if (dir == "W") wind = W;
	else if (dir == "NW") wind = NW;
	else if (dir == "NE") wind = NE;
	else if (dir == "SE") wind = SE;
	else if (dir == "SW") wind = SW;
	else if (dir == "NONE") wind = NONE;
}

void configuration::load_fuel()
{
	fuel = new int*[width];
	for (int i = 0; i < width; i++)
	{
		fuel[i] = new int[height];
	}
	for (int j = 0; j < height; j++)
	{
		for (int i = 0; i < width; i++)
		{
			data >> fuel[i][j];
		}
	}
}

void configuration::load_fire()
{
	fire = new bool*[width];
	for (int i = 0; i < width; i++)
	{
		fire[i] = new bool[height];
	}
	for (int j = 0; j < height; j++)
	{
		for (int i = 0; i < width; i++)
		{
			int value;
			data >> value;
			fire[i][j] = (value != 0);
		}
	}
}

configuration::~configuration()
{
	for (int j = 0; j < width; j++)
	{
		delete [] fuel[j];
		delete [] fire[j];
	}
	delete [] fuel;
	delete [] fire;
}
