#include "fireCellWind.h"

Direction fireCellWind::wind = NONE;
#define WEST dout[0][1][1]
#define EAST dout[2][1][1]
#define NORTH dout[1][0][1]
#define SOUTH dout[1][2][1]
#define NORTHWEST dout[0][0][1]
#define NORTHEAST dout[2][0][1]
#define SOUTHWEST dout[0][2][1]
#define SOUTHEAST dout[2][2][1]

fireCellWind::fireCellWind():
fireCell()
{
}

void fireCellWind::output_func(adevs_bag<PortValue>& y)
{
	double sign = 0.0;
	if (phase == BURNT)
	{
		sign = -1.0;
	}
	else if (phase == BURNING)
	{
		sign = 1.0;
	}
	else
	{
		return;
	}
	switch(wind)
	{
		case N:
			output(NORTH,sign*2.0,y);
			output(NORTHWEST,sign*2.0,y);
			output(NORTHEAST,sign*2.0,y);
			output(EAST,sign*1.0,y);
			output(WEST,sign*1.0,y);
			output(SOUTHEAST,sign*1.0,y);
			output(SOUTHWEST,sign*1.0,y);
			output(SOUTH,sign*1.0,y);
			break;
		case S:
			output(NORTH,sign*1.0,y);
			output(NORTHWEST,sign*1.0,y);
			output(NORTHEAST,sign*1.0,y);
			output(EAST,sign*1.0,y);
			output(WEST,sign*1.0,y);
			output(SOUTHEAST,sign*2.0,y);
			output(SOUTHWEST,sign*2.0,y);
			output(SOUTH,sign*2.0,y);
			break;
		case E:
			output(NORTH,sign*1.0,y);
			output(NORTHWEST,sign*1.0,y);
			output(NORTHEAST,sign*2.0,y);
			output(EAST,sign*2.0,y);
			output(WEST,sign*1.0,y);
			output(SOUTHEAST,sign*2.0,y);
			output(SOUTHWEST,sign*1.0,y);
			output(SOUTH,sign*1.0,y);
			break;
		case W:
			output(NORTH,sign*1.0,y);
			output(NORTHWEST,sign*2.0,y);
			output(NORTHEAST,sign*1.0,y);
			output(EAST,sign*1.0,y);
			output(WEST,sign*2.0,y);
			output(SOUTHEAST,sign*1.0,y);
			output(SOUTHWEST,sign*2.0,y);
			output(SOUTH,sign*1.0,y);
			break;
		case NW:
			output(NORTH,sign*2.0,y);
			output(NORTHWEST,sign*2.0,y);
			output(NORTHEAST,sign*1.0,y);
			output(EAST,sign*1.0,y);
			output(WEST,sign*2.0,y);
			output(SOUTHEAST,sign*1.0,y);
			output(SOUTHWEST,sign*1.0,y);
			output(SOUTH,sign*1.0,y);
			break;
		case NE:
			output(NORTH,sign*2.0,y);
			output(NORTHWEST,sign*1.0,y);
			output(NORTHEAST,sign*2.0,y);
			output(EAST,sign*2.0,y);
			output(WEST,sign*1.0,y);
			output(SOUTHEAST,sign*1.0,y);
			output(SOUTHWEST,sign*1.0,y);
			output(SOUTH,sign*1.0,y);
			break;
		case SW:
			output(NORTH,sign*1.0,y);
			output(NORTHWEST,sign*1.0,y);
			output(NORTHEAST,sign*1.0,y);
			output(EAST,sign*1.0,y);
			output(WEST,sign*2.0,y);
			output(SOUTHEAST,sign*1.0,y);
			output(SOUTHWEST,sign*2.0,y);
			output(SOUTH,sign*2.0,y);
			break;
		case SE:
			output(NORTH,sign*1.0,y);
			output(NORTHWEST,sign*1.0,y);
			output(NORTHEAST,sign*1.0,y);
			output(EAST,sign*2.0,y);
			output(WEST,sign*1.0,y);
			output(SOUTHEAST,sign*2.0,y);
			output(SOUTHWEST,sign*1.0,y);
			output(SOUTH,sign*2.0,y);
			break;
		case NONE:
			output(out,sign,y);
			break;
	}
}

fireCellWind::~fireCellWind()
{
}

void fireCellWind::setWindDirection(Direction wind)
{
	fireCellWind::wind = wind;
}
