#ifndef __fireCellWind_h_
#define __fireCellWind_h_
#include <adevs.h>
#include <iostream>
#include "fireCell.h"

typedef enum { N, S, E, W, NW, NE, SW, SE, NONE } Direction;

/**
A forest fire cell that accounts for wind direction.
*/
class fireCellWind: public fireCell
{
	public:
		// Constructor
		fireCellWind();
		// Output function
		void output_func(adevs_bag<PortValue>& y);
		// Destructor
		~fireCellWind();
		// Set the wind direction.  The wind blows in the same direction everywhere.
		static void setWindDirection(Direction wind);

	protected:
		static Direction wind;

};

#endif
