#include "mobile_example.h"
using namespace std;

int main()
{
	// Create two networks and move a model from one to the other

	// The first network has an atomic component at the start.  The atomic
	// component schedule internal events for every 0.8 seconds, and it will
	// do this 3 times.  The network executive will undergo an internal event
	// in 1 second and produce its component model as an output.
	mobile_example* t1 = new mobile_example(true,1.0,0.8,3);
	// The second network has no components initially.
	mobile_example* t2 = new mobile_example(false);
	// Connect the two models using the staticDigraph network model.
	staticDigraph dig;
	dig.add(t1);
	dig.add(t2);
	dig.couple(t1,0,t2,0);
	dig.couple(t2,0,t1,0);
	// Run the simulation
	devssim sim(&dig);
	sim.run();
}
