#include "adevs.h"
#include <cmath>
#include <iostream>
using namespace std;

/**
Solves dy/dt = sin(x) using the QSS1 integrator.
*/

// Differential function
double f(double x)
{
	return sin(x);
}

int main()
{
	// Integration quantum
	double D = 0.00075;
	// Simulation end time
	double tend = 5.5;
	// Initial condition
	double x = 3.14;
	// Simulation clock
	double t = 0.0;
	// Differential function value
	double dx = f(x);
	// Create and initialize the integrator
	qode q;
	q.setParams(D);
	q.init(x,dx);
	while (t < tend)
	{
		// Print the solution at time t
		cout << t << " " << x << endl;
		// Get the time of next event
		t += q.ta();
		// Get the value of the solution at t
		x = q.out();
		// Compute the next value of the derivative function
		dx = f(x);
		// Do the next integration step
		q.integ(q.ta(),dx);
	}
	// Done!
	return 0;
}
