#ifndef __phold_model_h_
#define __phold_model_h_
#include "adevs.h"
#include <list>

/**
This is the base class for all models in the phold network.
It is used as a 'mixin' or 'interface' class and should be
inhereted in tandem with the necessary atomic or devsn base
class.
*/
class phold_node
{
	public:
		// Interface definition for all phold models
		static const port_t in;
		static const port_t out;

		// Default constructor
		phold_node();
		// Destructor
		virtual ~phold_node();
		/**
		The adjacency list contains a pointer to every
		model that is attached to the output of this
		phold node.
		*/
		std::list<devs*> adj;
		// Global performance statistics
		static unsigned long event_count;
		static unsigned long models_created;
		static unsigned long models_destroyed;
};

#endif
