#include "phold_queue.h"
using namespace std;

phold_queue::phold_queue(bool originate_token):
atomic(),
phold_node()
{
	if (originate_token)
	{
		q.push_back(0x00);
	}
}

void phold_queue::init()
{
	if (!q.empty())
	{
		hold(r.exp(1.0));
	}
	else
	{
		passivate();
	}
}

void phold_queue::delta_int()
{
	event_count++;
	q.pop_front();
	if (!q.empty())
	{
		hold(r.exp(1.0));
	}
	else
	{
		passivate();
	}
}

void phold_queue::delta_ext(double e, const adevs_bag<PortValue>& x)
{
	event_count++;
	if (q.empty())
	{
		hold(r.exp(1.0));
	}
	// Otherwise, continue with tN unchanged

	for (int i = 0; i < x.getSize(); i++)
	{
		q.push_back(0x00);
	}
}
		
void phold_queue::delta_conf(const adevs_bag<PortValue>& x)
{
	delta_int();
	delta_ext(0.0,x);
	// Avoid double counting a confluent event
	event_count--;
}

void phold_queue::output_func(adevs_bag<PortValue>& y)
{
	output(out,NULL,y);
}

phold_queue::~phold_queue()
{
}
