#ifndef __phold_queue_h_
#define __phold_queue_h_
#include "adevs.h"
#include "phold_node.h"
#include <deque>

/**
A queue in the phold benchmark.
*/
class phold_queue: public atomic, public phold_node
{
	public:
		/**
		If the constructor flag is true, then this phold_queue will begin
		the simulation with a token in its queue.
		*/
		phold_queue(bool originate_token = false);
		/// Adevs atomic model methods
		void init();
		void delta_int();
		void delta_ext(double e, const adevs_bag<PortValue>& x);
		void delta_conf(const adevs_bag<PortValue>& x);
		void output_func(adevs_bag<PortValue>& y);
		/// No garbage collection is needed since the tokens are primitive types
		void gc_output(adevs_bag<PortValue>& g){}
		/// Destructor
		~phold_queue();
	private:
		/// The outgoing token queue
		std::deque<char> q;
		/// Random variable for determining token hold times
		rv r;
};

#endif
