#include "Community.h"
using namespace std;

Community::net_exec::net_exec(double rumor, int population, 
int connectivity, double* output, devsn* parent):
netExec(parent)
{
	srandom(time(NULL));
	vector<rumorMonger*> initial;
	for (int i = 0; i < population; i++)
	{
		double* output_mirror = NULL;
		if (output != NULL)
		{
			output_mirror = &(output[i]);
		}
		if (i == 0) 
		{ 
			initial.push_back(new rumorMonger(rumor,output_mirror));
		}
		else
		{
			initial.push_back(new rumorMonger(0.0,output_mirror));
		}
	}
	for (int i = 0; i < population; i++)
	{
		for (int j = 0; j < connectivity; j++)
		{
			int select = random()%population;
			if (select != i)
			{
				pop[initial[i]].push_back(initial[select]);
			}
		}
	}
}
			
void Community::net_exec::init()
{
	passivate();
}

void Community::net_exec::getComponents(adevs_set<devs*>& c)
{
	map<devs*,vector<devs*> >::iterator i;
	for (i = pop.begin(); i != pop.end(); i++)
	{
		c.add((*i).first);
	}
}

void Community::net_exec::route(
const PortValue& pv, devs* model, adevs_bag<EventReceiver>& r)
{
	vector<devs*> targets(pop[model]);
	vector<devs*>::iterator i = targets.begin();
	for (; i != targets.end(); i++)
	{
		EventReceiver ev(*i,rumorMonger::gossip_in);
		r.add(ev);
	}
}

Community::net_exec::~net_exec()
{
	map<devs*,vector<devs*> >::iterator i;
	for (i = pop.begin(); i != pop.end(); i++)
	{
		delete (*i).first;
	}
}
