#ifndef __Comunnity_h_
#define __Comunnity_h_
#include "adevs.h"
#include "rumorMonger.h"
#include <map>
#include <vector>
/**
A community of rumormongers.  Each rumormonger is connected, at random,
to a fixed set of other rumormongers.
*/
class Community: public devsn
{
	public:

		/**
		Creates a space with the specified number of rumorMongers
		and their connectivity.  The rumor argument is the initial
		rumor strength.  The optional output argument will contain
		the output values of the individual rumorMonger objects.  Its
		size should be equal to the population argument.
		*/
		Community(double rumor, int population, int connectivity, double* output = NULL):
		devsn()
		{
			nx = new net_exec(rumor, population,connectivity,output,this);
		}
		/// Get the network executive for this coupled model
		netExec* getNetExec() { return nx; }
		/// Destructor
		~Community(){ delete nx; }
	private:	
		class net_exec: public netExec
		{
			public:
				net_exec(double rumor, int population, int connectivity, 
				double* output, devsn* parent);
				void init();
				void delta_int(){}
				void delta_ext(ADEVS_TIME_TYPE e, const adevs_bag<PortValue>& x){}
				void delta_conf(const adevs_bag<PortValue>& x){}
				void output_func(adevs_bag<PortValue>& y){}
				void gc_output(adevs_bag<PortValue>& g){}
				void gc_models(adevs_set<devs*>& g){}
				void getComponents(adevs_set<devs*>& c);
				void route(const PortValue& pv, devs* model, adevs_bag<EventReceiver>& r);
				~net_exec();
			private:
				std::map<devs*,std::vector<devs*> > pop;
		};
		net_exec* nx;
};

#endif
