#include "Community.h"
#include <iostream>
using namespace std;

static int population = 20;
static double* mirror = new double[population];

// Display the state of the world using the mirrored output variable.
void display()
{
	for (int i = 0; i < population; i++)
	{
		cout << rint(mirror[i]) << " ";
	}
	cout << endl;
	for (int i = 0; i < population; i++)
	{
		mirror[i] = 0.0;
	}
}

int main()
{
	Community model(2.0,population,3,mirror);
	try
	{
		xdevssim sim(&model);
		sim.initialize();
		while (sim.nextTN() < ADEVS_INFINITY)
		{
			display();
			sim.deltFunc(sim.nextTN());
		}
		sim.finalize();
	}
	catch(adevs_exception err)
	{
		cout << err << endl;
	}
	return 0;
}
