/* solver.c **********************************************\
*                                                         *
*  Exact Newton-type iterative Riemann solver of Godunov  *
*                                                         *
*  written by  Andrei A. Chernousov                       *
*  E-mail: <andrei99@iname.com>                           *
*  http://www.geocities.com/andrei_chernousov             *
*  November 23, 2000                                      *
**********************************************************/
#ifndef __params_h_
#define __params_h_
#include "adevs_vec.h"

/* complexes with the ratio of specific heats */
#define K        1.4
#define K_1_2    0.2
#define K_1      0.4
#define K_K      0.142857142857
#define _2K_K_1  7.0
#define K__1_2   1.2
#define K__1_2K  0.857142857143
#define K_1_2K   0.142857142857
#define K_1_K__1 0.166666666667
#define K_K_1    3.5
#define _2_K__1  0.833333333333
#define K__1     2.4
#define _3K_1    3.2
#define _2_K_1   5.0
#define _4K      5.6

adevs_vec<3> fluxes(const adevs_vec<3>& ul, const adevs_vec<3>& ur);

#endif
