/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include "physics.h"
#include <math.h>

stime_t timeToDist(double distance, const vec& v) 
{
	double l = v.length();
	if (l == 0.0) return INFINITY; 
	else return distance / l;
}

vec distInTime(stime_t t, const vec& v) 
{
	return vec(v*t);
}

vec elasticCollision(const vec& v, double theta_impact) 
{
	vec reflected = v;
	return reflected.reflect(2 * PI - theta_impact);
}
