/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#ifndef __physics_h_
#define __physics_h_
#include <adevs.h>
#include "shape.h"

#ifndef PI
#define PI 3.14159265
#endif

/**
Equations of motion in 2 dimensions.
*/
stime_t timeToDist(double distance, const vec& velocity);
vec distInTime(stime_t t, const vec& velocity);
vec elasticCollision(const vec& velocity, double theta_impact);

#endif
