/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <math.h>
#include "vec.h"

double vec::length() const 
{
	return sqrt (x * x + y * y);
}

/**
Transformations are hard coded.
*/
vec& vec::rotate(double radians) 
{
	double Xnew, Ynew;
	Xnew = x * cos (radians) - y * sin (radians);
	Ynew = x * sin (radians) + y * cos (radians);
	x = Xnew;
	y = Ynew;
	return *this;
}

vec& vec::reflect (double radians) 
{
	double c = cos (radians);
	double s = sin (radians);
	double Xnew, Ynew;
	Xnew = (2*c*c-1)*x + 2*c*s*y;
	Ynew = 2*c*s*x + (2*s*s-1)*y;
	x = Xnew;
	y = Ynew;
	return *this;
}


vec operator*(double x, const vec& v)
{
	return vec(v*x);
}
