/***************
adevs, a library supporting discrete event simulation
Copyright (C) 2005 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutarojj@ornl.gov
***************/
#ifndef __adevs_linux_numa_wrapper
#define __adevs_linux_numa_wrapper

/**
Wrappers around the Linux numa library.  The wrapped functions have no effect if the
ADEVS_USE_NUMA flag is not defined in the adevs_config file.  These methods have
process wide effect, so be judicious with their use.  The 
functions are otherwise identical to the numa library functions.  However, initialization
is checked for and performed internally, so the end user does not need to worry about it.
*/

/**
Future memory allocations will be done on the specified processor.
*/
void adevs_linux_numa_set_preferred(int node);
/**
The current thread will be run on the specified processor.
This is used internally by the simulation engine, and should not
be needed by the end user.
*/
void adevs_linux_numa_run_on_node(int node);

#endif
