#ifndef __empty_pthread_h_
#define __empty_pthread_h_
/**
This is a set of pthread definitions that are bogus, and are intended for
compiling adevs on systems that do not support pthreads.  Every function
tosses an exception when it is called.  The result of this is that the
library will toss an exception if any of the parallel features are used
on a non-posix os.
*/

/* Replace pthread types with char */
#define pthread_t char
#define pthread_cond_t char
#define pthread_mutex_t char

/* Replace function calls with exceptions */
#define pthread_mutex_lock(x) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_mutex_unlock(x) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_mutex_init(x,y) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_mutex_destroy(x) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_cond_wait(x,y) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_cond_broadcast(x) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_cond_init(x,y) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_cond_destroy(x) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_join(x,y) THROW_BASE_EXCEPTION("pthreads not supported")
#define pthread_create(x,y,u,v) THROW_BASE_EXCEPTION("pthreads not supported")

#endif
