#include <iostream>
#include <adevs.h>
#include <assert.h>
using namespace std;
USING_NAMESPACE_ADEVS

class genr: public atomic
{
	public:
		static const ADEVS_PORT_TYPE out;

		genr(ADEVS_TIME_TYPE period, int ticks):
		atomic(),
		period(period),
		ticks(ticks),
		count(0)
		{
		}
		void init()
		{
			count = 0;
			hold(period);
			assert(timeCurrent() == ADEVS_ZERO);
			assert(timeLast() == ADEVS_ZERO);
		}
		void delta_int()
		{
			assert(timeCurrent() == timeLast()+ta());
			assert(elapsed() == ta());
			count++;
			assert(count <= ticks);
			if (count == ticks) passivate();
			else hold(period);
		}
		void delta_ext(ADEVS_TIME_TYPE e, const adevs_bag<PortValue>& x)
		{
			assert(false);
		}
		void delta_conf(const adevs_bag<PortValue>& x)
		{
			assert(false);
		}
		void output_func(adevs_bag<PortValue>& y)
		{
			output(out,new object(),y);
		}
		void gc_output(adevs_bag<PortValue>& g)
		{
			for (int i = 0; i < g.getSize(); i++) 
			{
				delete g[i].value;
			}
		}
		~genr()
		{
		}
		int getTickCount() { return count; }
	private:
		ADEVS_TIME_TYPE period;
		int ticks;
		int count;
};

const ADEVS_PORT_TYPE genr::out(1);

void test1()
{
	genr* g = new genr(10.0,10);
	devssim sim(g);
	sim.run();
	assert(g->getTickCount() == 10);
	delete g;
}

void test2()
{
	genr* g = new genr(-1.0,10);
	try
	{
		devssim sim(g);
		assert(false);
	}
	catch(adevs_exception& err)
	{
		std::cerr<<err.getErrorMsg()<<std::endl;
	}
	delete g;
}

void test3()
{
	genr* g = new genr(1.0,10);
	devssim sim(g);
	while (sim.timeNext() < ADEVS_INFINITY)
	{
		sim.step(sim.timeNext()-sim.timeLast());
	}
	assert(g->getTickCount() == 10);
	delete g;
}

int main()
{
	test1();
	test2();
	test3();
	return 0;
}
