#include <adevs_bag.h>
#include <assert.h>
#include <iostream>
using namespace std;
USING_NAMESPACE_ADEVS

#define ARRAY_SIZE 100

void test1()
{
	int test_array [ARRAY_SIZE];
	for (int i = 0; i < ARRAY_SIZE; i++) 
	   test_array[i] = i;
	adevs_bag<int> l;
	assert (l.getSize() == 0);
	assert (l.getCapacity() == BAG_DEFAULT_CAP);
	for (int i = 0; i < ARRAY_SIZE; i++) 
	{
		l.add(i);
		assert(l.getSize() ==i+1);
		assert (l.getCapacity() >= l.getSize());
		assert(l[i] == i);
	}

	for (int i = 0; i < l.getSize() / 2; i++) 
	{
		l.swap(i,ARRAY_SIZE-i-1);
		assert(l[i] == test_array[ARRAY_SIZE-i-1]);
	}

	for (int i = 0; i < l.getSize() / 2; i++) 
	{
		l.swap (i,ARRAY_SIZE-i-1);
	}

	int size = l.getSize();
	for (int i = 0; i < size / 2; i++) 
	{
		int temp = l[l.getSize()-1];
		l.remove(0);
		assert(temp == l[0]);
	}
	assert (l.getSize()==ARRAY_SIZE-ARRAY_SIZE/2);

	adevs_bag<int> store(l);
	assert(l.getSize()==store.getSize());
	assert(l.getCapacity()==store.getCapacity());
	for (int i = 0; i < l.getSize(); i++) 
	{
		assert (l.get(i) == store[i]);
	}

	adevs_bag<int> al = store; 
	assert(al.getSize()==store.getSize());
	assert(al.getCapacity()==store.getCapacity());
	for (int i = 0; i < store.getSize (); i++) 
	{
		assert (al.get(i) == store[i]);
	}

	al.removeAll();
	assert(al.getSize() == 0);

}

void test2()
{
	int test_array [ARRAY_SIZE];
	adevs_bag<int> l;
	adevs_bag<int> k;
	for (int i = 0; i < ARRAY_SIZE; i++) 
	{
		test_array[i] = i;
		l.add(i);
		k.add(i);
	}

	k.append(l);
	assert (k.getSize() == l.getSize()*2);
	for (int i = 0; i < k.getSize (); i++)
		assert (l[i%l.getSize()] == k[i]);
}

int main()
{
	test1();
	test2();
	return 0;
}
