#include "adevs.h"
#include <iostream>
#include <fstream>
#include <stdio.h>
using namespace std;
USING_NAMESPACE_ADEVS

class cell_model: public cell_interface, public atomic
{
	public:
		cell_model():
		cell_interface(),
		atomic()
		{
		}
		cell_model(const cell_model& src):
		cell_interface(src),
		atomic(src)
		{
		}
		const cell_model& operator=(const cell_model& src)
		{
			cell_interface::operator=(src);
			atomic::operator=(src);
			return *this;
		}
		void init(){}
		void delta_int(){}
		void delta_ext(double e, const adevs_bag<PortValue>& x){}
		void delta_conf(const adevs_bag<PortValue>& x){}
		void gc_output(adevs_bag<PortValue>& g){}
		void output_func(adevs_bag<PortValue>& g){}
		~cell_model()
		{
		}
};

int main()
{
	int width = 13;
	int height = 7;
	int depth = 29;
	cellSpace* space = new cellSpace(cellSpace::TWENTY_SIX_POINT,width,height,depth);
	for (int x = 0; x < width; x++)
	{
		for (int y = 0; y < height; y++)
		{
			for (int z = 0; z < depth; z++)
			{
				int xx, yy, zz;
				unsigned long key = cell_interface::get_key(x,y,z,width,height);
				cell_interface::get_coord(xx,yy,zz,width,height,key);
				assert(xx == x && yy == y && zz == z);
				space->add(new cell_model(),x,y,z);
			}
		}
	}
	for (int x = 0; x < width; x++)
	{
		for (int y = 0; y < height; y++)
		{
			for (int z = 0; z < depth; z++)
			{
				const cell_interface* cll = 
				dynamic_cast<const cell_interface*>(space->getModel(x,y,z));
				assert(space->getPort(x,y,z) == cll->get_key());
				cellSpace::coord_t c = 
				space->getCoordinates(space->getPort(x,y,z));
				assert(c.x==x && c.y==y && c.z==z);
			}
		}
	}
}
