#ifndef __cell_h_
#define __cell_h_
#include "adevs.h"
USING_NAMESPACE_ADEVS

class genr: public atomic 
{
	public:
		static const ADEVS_PORT_TYPE out;

		genr(ADEVS_TIME_TYPE period,object* id):
		atomic(),
		period(period),
		id(id){}
		void init() 
		{
			hold(period);
		}
		void delta_int() 
		{ 
			hold(period); 
		}
		void delta_ext(ADEVS_TIME_TYPE e, 
		const adevs_bag<PortValue>& x){}
		void delta_conf(const adevs_bag<PortValue>& x){}
		void output_func(adevs_bag<PortValue>& y) 
		{ 
			output(out,id,y); 
		}
		void gc_output(adevs_bag<PortValue>& g){}
	private:
		ADEVS_TIME_TYPE period;
		object* id;
};

class cell: public staticDigraph 
{
	public:
		static const ADEVS_PORT_TYPE die;
		static const ADEVS_PORT_TYPE birth;

		cell():
		staticDigraph()
		{
			genr* life = new genr(2.0,this);
			genr* reproduction = new genr(1.0,this);
			add(life);
			add(reproduction);
			couple(life,life->out,this,die);
			couple(reproduction,reproduction->out,this,birth);
			pop++;
		}
		~cell() { pop--; }
		static int getPop() { return pop; }

	private:
		static int pop;

};

int cell::pop(0);
const ADEVS_PORT_TYPE genr::out(0);
const ADEVS_PORT_TYPE cell::die(1);
const ADEVS_PORT_TYPE cell::birth(2);

#endif
