#include "configuration.h"
using namespace std;

configuration::configuration(std::string config_file)
{
	std::string field;
	data.open(config_file.c_str());
	while (!data.eof())
	{
		data >> field;
		if (data.eof()) break;
		if (field == "width") data >> width;
		else if (field == "height") data >>height;
		else if (field == "tend") data >> tend;
		else if (field == "fuel") load_fuel();
		else if (field == "fire") load_fire();
	}
	data.close();
}

void configuration::load_fuel()
{
	fuel = new int*[width];
	for (int i = 0; i < width; i++)
		fuel[i] = new int[height];
	for (int i = 0; i < width; i++)
		for (int j = 0; j < height; j++)
		data >> fuel[i][j];
}

void configuration::load_fire()
{
	fire = new bool*[width];
	for (int i = 0; i < width; i++)
		fire[i] = new bool[height];
	for (int i = 0; i < width; i++)
	{
		for (int j = 0; j < height; j++)
		{
			int value;
			data >> value;
			fire[i][j] = (value != 0);
		}
	}
}

void configuration::get_data(int x, int y, int w, int h, int** fuel_, bool** fire_)
{
	for (int i = x; i < x+w; i++)
	{
		for (int j = y; j < y+h; j++)
		{
			fuel_[i-x][j-y] = fuel[i][j];
			fire_[i-x][j-y] = fire[i][j];
		}
	}
}

configuration::~configuration()
{
	for (int j = 0; j < width; j++)
	{
		delete [] fuel[j];
		delete [] fire[j];
	}
	delete [] fuel;
	delete [] fire;
}
