#ifndef __fireCell_h_
#define __fireCell_h_
#include "adevs.h"
USING_NAMESPACE_ADEVS

class fireCell: public atomic, public cell_interface
{
	public:
		fireCell();
		fireCell(const fireCell& src);
		const fireCell& operator=(const fireCell& src);
		void init();
		void delta_int();
		void delta_ext(ADEVS_TIME_TYPE e, const adevs_bag<PortValue>& x);
		void delta_conf(const adevs_bag<PortValue>& x);
		void output_func(adevs_bag<PortValue>& _y);
		void gc_output(adevs_bag<PortValue>& g);
		void report(std::ofstream& stream) const;
		object* clone() const;
		~fireCell();
		void set_init_conditions(int fuel, bool burning);

	private:
		CellPhase phase;
		int fuel, heat;
};

#endif
