#include "adevs.h"
#include <cstdio>
#include <cassert>
#ifndef __counter_h_
#define __counter_h_
USING_NAMESPACE_ADEVS

class counter: public atomic 
{
	public:
		static const ADEVS_PORT_TYPE in;

		counter::counter():atomic(),count(0){}
		counter::counter(const counter& src):atomic(src),count(src.count){}
		object* clone() const { return new counter(*this); }
		void init()
		{
			count = 0;
			passivate();
		}
		void delta_int() 
		{ 
			passivate(); 
		}
		void delta_ext(ADEVS_TIME_TYPE t, const adevs_bag<PortValue>& x) 
		{
			for (int i = 0; i < x.getSize(); i++)
			{
				assert(x.get(i).port == in);
			}
			count += x.getSize();
			printf("Count is %d @ %d\n",count,(int)timeCurrent());
			passivate(); 
		} 
		void delta_conf(const adevs_bag<PortValue>& x)
		{
			assert(false);
		}
		void output_func(adevs_bag<PortValue>& y)
		{
			assert(false);
		}
		void gc_output(adevs_bag<PortValue>& g)
		{
			assert(g.getSize() == 0);
		}
		~counter(){}
	private:	
		int count;
};

const ADEVS_PORT_TYPE counter::in(0);

#endif
