#ifndef __gcd_h_
#define __gcd_h_
#include "genr.h"
#include "counter.h"
#include "delay.h"
USING_NAMESPACE_ADEVS

class gcd: public staticDigraph 
{
	public:
		static const ADEVS_PORT_TYPE in;
		static const ADEVS_PORT_TYPE out;
		static const ADEVS_PORT_TYPE signal;
		static const ADEVS_PORT_TYPE start;
		static const ADEVS_PORT_TYPE stop;

		gcd(const std::vector<ADEVS_TIME_TYPE>& pattern, ADEVS_TIME_TYPE dt,
		int iterations, bool active = false):staticDigraph()
		{
			genr* g = new genr(pattern,iterations,active);
			delay* d = new delay(dt);
			counter* c = new counter;
			build(g,c,d);
		}
		gcd(ADEVS_TIME_TYPE period, ADEVS_TIME_TYPE dt, 
		int iterations, bool active = false):staticDigraph()
		{
			genr* g = new genr(period,iterations,active);
			delay* d = new delay(dt);
			counter* c = new counter;
			build(g,c,d);
		}
		gcd(const gcd& src):staticDigraph(src){}
		object* clone() const { return new gcd(*this); }
		~gcd(){}
	private:
		void build(genr* g, counter* c, delay* d) 
		{
			add(g);
			add(d);
			add(c);
			couple(this,in,d,d->in);
			couple(this,start,g,g->start);
			couple(this,stop,g,g->stop);
			couple(g,g->signal,this,signal);
			couple(d,d->out,this,out);
			couple(d,d->out,c,c->in);
		}
};

const ADEVS_PORT_TYPE gcd::in(0);
const ADEVS_PORT_TYPE gcd::out(1);
const ADEVS_PORT_TYPE gcd::start(2);
const ADEVS_PORT_TYPE gcd::stop(3);
const ADEVS_PORT_TYPE gcd::signal(4);

#endif
