#include <iostream>
#include "adevs.h"
#include "gcd.h"
USING_NAMESPACE_ADEVS
int main() 
{
	try
	{
		std::cout << "Test 3x" << std::endl;
		staticDigraph model;
		gcd* c = new gcd(10.0,2.0,5,false);
		genr* g = new genr(10.0,10,true);
		model.couple(g,g->signal,c,c->in);
		xdevssim sim(&model,true);
		sim.initialize();
		double tN = sim.nextTN();
		while (sim.nextTN() < ADEVS_INFINITY)
		{
			tN = sim.nextTN();
			sim.deltFunc(sim.nextTN());
		}
		sim.remove_fossils(tN/1.5);
		sim.restore_state(tN/2.0);
		while (sim.nextTN() < ADEVS_INFINITY)
		{
			tN = sim.nextTN();
			sim.deltFunc(sim.nextTN());
		}
		sim.finalize();
		std::cout << "Test done" << std::endl;
	}
	catch(adevs_exception& err)
	{
		std::cout << err.getErrorMsg() << std::endl;
		assert(false);
	}
return 0;
}
