#ifndef __mobile_test_h_
#define __mobile_test_h_
#include "adevs.h"
#include "simple_atomic.h"
#include <iostream>

class mobile_test: public devsn
{
	public:
		mobile_test(bool initial_model, double transfer_time = ADEVS_INFINITY,
		double simple_output_time = ADEVS_INFINITY, int simple_event_limit = 1):
		devsn(),
		nx(initial_model,transfer_time,simple_output_time,simple_event_limit,this)
		{
		}
		netExec* getNetExec() { return &nx; }
	private:
		class mobile_net_exec: public netExec
		{
			public:
				mobile_net_exec(bool initial_model, double transfer_time, 
				double simple_output_time,int event_limit,devsn* parent):
				netExec(parent),
				event_limit(event_limit),
				initial_model(initial_model),
				transfer_time(transfer_time),
				simple_output_time(simple_output_time)
				{
				}
				void init()
				{
					if (initial_model) model = 
						new simple_atomic(simple_output_time,event_limit);
					else model = NULL;
					hold(transfer_time);
				}
				void delta_int()
				{
					if (model != NULL)
					{
						std::cout << "Sent a model at time " << timeCurrent() << std::endl;
					}
					model = NULL;
					passivate();
				}
				void delta_ext(double e, const adevs_bag<PortValue>& x)
				{
					model = dynamic_cast<devs*>(x.get(0).value);
					std::cout << "Received a model at time " << timeCurrent() << std::endl;
					hold(transfer_time);
				}
				void delta_conf(const adevs_bag<PortValue>& x)
				{
					delta_int();
					delta_ext(0.0,x);
				}
				void output_func(adevs_bag<PortValue>& y)
				{
					if (model != NULL) output(0,model,y);
				}
				void getComponents(adevs_set<devs*>& c)
				{
					if (model != NULL) c.add(model);
				}
				void gc_models(adevs_set<devs*>& g)
				{
					for (int i = 0; i < g.getSize(); i++)
					{
						delete g[i];
					}
				}
				void gc_output(adevs_bag<PortValue>& g)
				{
				}
				void route(const PortValue& pv, devs* model, adevs_bag<EventReceiver>& r)
				{
					if (model == getParent())
					{
						EventReceiver rx(this,0);
						r.add(rx);
					}
					else if (model == this)
					{
						EventReceiver rx(getParent(),0);
						r.add(rx);
					}
				}
				~mobile_net_exec()
				{
					if (model != NULL) delete model;
				}
			private:
				devs* model;
				int event_limit;
				bool initial_model;
				double transfer_time, simple_output_time;
		};
		mobile_net_exec nx;
};

#endif


						
		
		
