#include <iostream>
#include <string>
#include "adevs.h"
USING_NAMESPACE_ADEVS

class pingpong: public atomic 
{
	public:
		static const ADEVS_PORT_TYPE out;
		static const ADEVS_PORT_TYPE in;

		pingpong(bool has_ball,const char* name):
		atomic(),has_ball(has_ball),hold_time(1.0),name(name){}

		void init()
		{
			if (has_ball) hold(hold_time);
			else passivate();
		}
		void delta_int()
		{
			has_ball = false;
			passivate();
		}
		void delta_ext(ADEVS_TIME_TYPE e, const adevs_bag<PortValue>& x)
		{
			std::cout << name << std::endl;
			hold(hold_time);
		}
		void delta_conf(const adevs_bag<PortValue>& x){}
		void output_func(adevs_bag<PortValue>& y)
		{
			output(out,new intg(),y);
		}
		void gc_output(adevs_bag<PortValue>& g)
		{
			for (int i = 0; i < g.getSize(); i++)
				delete g[i].value;
		}
		~pingpong(){}
	private:	
		bool has_ball;
		ADEVS_TIME_TYPE hold_time;
		std::string name;
};

const ADEVS_PORT_TYPE pingpong::out = 0;
const ADEVS_PORT_TYPE pingpong::in = 1;
