#include <adevs_set.h>
#include <assert.h>
#include <iostream>
USING_NAMESPACE_ADEVS

#define ARRAY_SIZE 100

void test1()
{
	int test_array [ARRAY_SIZE];
	for (int i = 0; i < ARRAY_SIZE; i++) 
	   test_array[i] = i;
	adevs_set<int> l;
	assert (l.getSize() == 0);
	assert (l.getCapacity() == BAG_DEFAULT_CAP);
	for (int i = 0; i < ARRAY_SIZE; i++) 
	{
		l.add(i);
		assert(l.getSize() ==i+1);
		assert (l.getCapacity() >= l.getSize());
		assert(l[i] == i);
		assert(l.contains(i));
	}

	for (int i = 0; i < l.getSize() / 2; i++) 
	{
		l.swap(i,ARRAY_SIZE-i-1);
		assert(l[i] == test_array[ARRAY_SIZE-i-1]);
	}

	for (int i = 0; i < l.getSize() / 2; i++) 
	{
		l.swap (i,ARRAY_SIZE-i-1);
	}

	int size = l.getSize();
	for (int i = 0; i < size / 2; i++) 
	{
		int temp = l[l.getSize()-1];
		l.remove(0);
		assert(temp == l[0]);
	}
	assert (l.getSize()==ARRAY_SIZE-ARRAY_SIZE/2);

	adevs_set<int> store(l);
	assert(l.getSize()==store.getSize());
	assert(l.getCapacity()==store.getCapacity());
	for (int i = 0; i < l.getSize(); i++) 
	{
		assert (l.get(i) == store[i]);
	}

	adevs_set<int> al = store; 
	assert(al.getSize()==store.getSize());
	assert(al.getCapacity()==store.getCapacity());
	for (int i = 0; i < store.getSize (); i++) 
	{
		assert (al.get(i) == store[i]);
	}

	al.removeAll();
	assert(al.getSize() == 0);

}

void test2()
{
	int test_array [ARRAY_SIZE];
	adevs_set<int> l;
	adevs_set<int> k;
	for (int i = 0; i < ARRAY_SIZE; i++) 
	{
		test_array[i] = i;
		l.add(i);
		k.add(i);
	}

	k.append(l);
	assert (k.getSize() == l.getSize());
	for (int i = 0; i < k.getSize (); i++)
		assert (l[i] == k[i]);
}

void test3()
{
	adevs_set<int> s;
	for (int i = 0; i < 100; i++)
	{
		s.add(i);
		s.add(i);
		assert(s.getSize()==i+1);
		assert(s.contains(i));
	}
	for (int i = 0; i < 100; i++)
	{
		int value = s[i];
		s.remove(i);
		assert(!s.contains(value));
	}
}

void test4()
{
	adevs_set<int> even;
	adevs_set<int> odd;
	for (int i = 0; i < 100; i++)
	{
		even.add(2*i);
		odd.add(2*i+1);
	}
	adevs_set<int> sub(even - odd);
	assert (sub.getSize() == 100);
	for (int i = 0; i < 100; i++)
	{
		odd.add(i);
	}
	sub = odd - even;
	assert(sub.getSize() == 100);
	for (int i = 0; i < 100; i++)
	{
		assert(sub.contains(2*i+1));
		assert(!sub.contains(2*i));
	}
}

void test5()
{
	adevs_set<int> a, b;
	assert(a.intersection(b).getSize() == 0);
	a.add(0);
	assert(a.intersection(b).getSize() == 0);
	b.add(0);
	assert(a.intersection(b).getSize() == 1);
	assert(a.intersection(b).contains(0) == 1);
	b.add(1);
	assert(a.intersection(b).getSize() == 1);
	assert(a.intersection(b).contains(0) == 1);
}

int main()
{
	test1();
	test2();
	test3();
	test4();
	test5();
	return 0;
}
