#include <iostream>
#include <assert.h>
#include "adevs.h"
#ifndef __node_h_
#define __node_h_
USING_NAMESPACE_ADEVS

class node: public atomic 
{
	public:
		static const ADEVS_PORT_TYPE in;
		static const ADEVS_PORT_TYPE out;

		node(int ID,int holdtime,intg* token,bool no_output = false):
		atomic(),ID(ID),holdtime(holdtime),token(token) {}
		void init() 
		{
			out_token = token;
			if (token != NULL) 
				hold(holdtime);
			else 
				passivate();
		}
		void delta_int()
		{
			assert(token != NULL);
			printf("%d sent %d @ t = %.0f\n",ID,out_token->value,timeCurrent());
//			std::cout<<ID<<" sent "<<out_token->value<<" @ t = "<<timeCurrent()<<std::endl;
			out_token = token;
			passivate();
		}
		void delta_ext(ADEVS_TIME_TYPE e, const adevs_bag<PortValue>& x)
		{
			assert (x.getSize() == 1);
			token = (intg*)(x.get(0).value);
			if (out_token == NULL) out_token = token;
			printf("%d got %d @ t = %.0f\n",ID,token->value,timeCurrent());
//			std::cout<<ID<<" got "<<token->value<<" @ t = "<<timeCurrent()<<std::endl;
			hold(holdtime);
		}
		void delta_conf(const adevs_bag<PortValue>& x) 
		{
			assert (x.getSize() == 1);
			printf("%d sent %d @ t = %.0f\n",ID,token->value,timeCurrent());
//			std::cout<<ID<<" sent "<<token->value<<" @ t = "<<timeCurrent()<<std::endl;
			token = (intg*)(x.get(0).value);
			out_token = token;
			printf("%d got %d @ t = %.0f\n",ID,token->value,timeCurrent());
//			std::cout<<ID<<" got "<<token->value<<" @ t = "<<timeCurrent()<<std::endl;
			hold(holdtime);
		}
		void output_func(adevs_bag<PortValue>& y)
		{
			output(out,out_token,y);
		}
		void gc_output(adevs_bag<PortValue>& g){}

		~node(){}
	private:	
		int ID;
		ADEVS_TIME_TYPE holdtime;
		intg* token;
		intg* out_token;
};
		
const ADEVS_PORT_TYPE node::in(0);
const ADEVS_PORT_TYPE node::out(1);

#endif
